// fonts.cpp: 2012-04-08 Fonts 
#pragma warning(disable : 4996)

#include <stdlib.h>

#include "fonts.h"

#include "Fonts\verdana07.h"
#include "Fonts\verdana07b.h"

#include "Fonts\verdana08.h"
#include "Fonts\verdana08b.h"

#include "Fonts\verdana09.h"
#include "Fonts\verdana09b.h"

#include "Fonts\verdana10.h"
#include "Fonts\verdana10b.h"

#include "Fonts\verdana11.h"
#include "Fonts\verdana11b.h"

#include "Fonts\verdana12.h"
#include "Fonts\verdana12b.h"

#include "Fonts\verdana14.h"
#include "Fonts\verdana14b.h"

#include "Fonts\verdana16.h"
#include "Fonts\verdana16b.h"
//=============================================================================
hFont::hFont() { font = NULL; h=w=0; }	// constructor
hFont::hFont(int garnitura, int typ, int size) { setFont(garnitura, typ, size); }// constructor
//-----------------------------------------------------------------------------
int hFont::setFont(int garnitura, int typ, int size)	// returns error code
{
	font=NULL; h=w=0;
	if( garnitura != FONT_VERDANA )					return 1;
	if( typ != FONT_USUAL && typ != FONT_BOLD )		return 2; 
	if( size<7 || size==13 || size==15 || size>16 ) return 3;

	if(typ==FONT_USUAL && size== 7){font=Fverdana07;  h=Fverdana07_H;  w=Fverdana07_W; }
	if(typ==FONT_BOLD  && size== 7){font=Fverdana07b; h=Fverdana07b_H; w=Fverdana07b_W;}

	if(typ==FONT_USUAL && size== 8){font=Fverdana08;  h=Fverdana08_H;  w=Fverdana08_W; }
	if(typ==FONT_BOLD  && size== 8){font=Fverdana08b; h=Fverdana08b_H; w=Fverdana08b_W;}

	if(typ==FONT_USUAL && size== 9){font=Fverdana09;  h=Fverdana09_H;  w=Fverdana09_W; }
	if(typ==FONT_BOLD  && size== 9){font=Fverdana09b; h=Fverdana09b_H; w=Fverdana09b_W;}

	if(typ==FONT_USUAL && size==10){font=Fverdana10;  h=Fverdana10_H;  w=Fverdana10_W; }
	if(typ==FONT_BOLD  && size==10){font=Fverdana10b; h=Fverdana10b_H; w=Fverdana10b_W;}

	if(typ==FONT_USUAL && size==11){font=Fverdana11;  h=Fverdana11_H;  w=Fverdana11_W; }
	if(typ==FONT_BOLD  && size==11){font=Fverdana11b; h=Fverdana11b_H; w=Fverdana11b_W;}

	if(typ==FONT_USUAL && size==12){font=Fverdana12;  h=Fverdana12_H;  w=Fverdana12_W; }
	if(typ==FONT_BOLD  && size==12){font=Fverdana12b; h=Fverdana12b_H; w=Fverdana12b_W;}

	if(typ==FONT_USUAL && size==14){font=Fverdana14;  h=Fverdana14_H;  w=Fverdana14_W; }
	if(typ==FONT_BOLD  && size==14){font=Fverdana14b; h=Fverdana14b_H; w=Fverdana14b_W;}

	if(typ==FONT_USUAL && size==16){font=Fverdana16;  h=Fverdana16_H;  w=Fverdana16_W; }
	if(typ==FONT_BOLD  && size==16){font=Fverdana16b; h=Fverdana16b_H; w=Fverdana16b_W;}

	if( w==0 ) return 4;
	for( int ch=0; ch<256; ch++ )
		wc[ch] = mRight(ch);
	return 0;
} // int hFont::setFont(int garnitura, int typ, int size)	// returns error code
//-----------------------------------------------------------------------------
bool hFont::isCharEmpty( int ch )	// is character empty?
{
	int chSize = h*(w>>3);
	unsigned char *f = font + ch*chSize;
	for( int i=0; i<chSize; i++ )
		if( f[i] ) return false;
	return true;
}
//-----------------------------------------------------------------------------
int  hFont::getBit(unsigned char ch, int x, int y)	// b/w of the point
{
	unsigned offs = ch*h*w + y*w + x;
	unsigned char f = font[offs>>3];
	unsigned x8 = 1<<(7-(x&7));
	return  (f & x8) == 0? 0 : 1;
}
//-----------------------------------------------------------------------------
int  hFont::mLeft (unsigned char ch)	// most left  point (-1 if char empty)
{
	for( int x=0; x<w; x++ )
	for( int y=0; y<h; y++ )
		if( getBit(ch, x, y)>0 ) return x;
	return 0;
}
int  hFont::mRight(unsigned char ch)	// most right point (-1 if char empty)
{
	for( int x=w-1; x>=0; x-- )
	for( int y=0; y<h; y++ )
		if( getBit(ch, x, y)>0 ) return x;
	return 0;
}
int  hFont::mTop  (unsigned char ch)	// most top   point (-1 if char empty)
{
	for( int y=0; y<h; y++ )
	for( int x=0; x<w; x++ )
		if( getBit(ch, x, y)>0 ) return y;
	return 0;
}
int  hFont::mBottom(unsigned char ch)	// most down  point (-1 if char empty)
{
	for( int y=h-1; y>=0; y-- )
	for( int x=0; x<w; x++ )
		if( getBit(ch, x, y)>0 ) return y;
	return 0;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------





//