// fonts.h: 2012-04-08 Fonts 

#ifdef H_FONTS
#error Secondary include
#endif
#define H_FONTS

#define FONT_VERDANA 1

// fonts types:
#define FONT_USUAL 1
#define FONT_BOLD  3

class hFont{
private:
	unsigned char *font;	// font byte array
	int h, w;				// height, width
	unsigned char wc[256];	// widths of every character

public:
	// constructors/destructor
	hFont();
	hFont(int garnitura, int typ, int size);
	//
	int  height() { return h; }
	int  width () { return w; }
	int  width (unsigned char ch) { return wc[ch]; }
	//
	int  setFont(int garnitura, int typ, int size);	// returns error code
	bool isCharEmpty( int ch );						// is character empty?
	int  getBit(unsigned char ch, int x, int y);	// b/w of the point

	int  mLeft (unsigned char ch);					// most left  point (0 if char empty)
	int  mRight(unsigned char ch);					// most right point (0 if char empty)
	int  mTop  (unsigned char ch);					// most top   point (0 if char empty)
	int  mBottom(unsigned char ch);					// most down  point (0 if char empty)
};

