// iMatrFonts.cpp:  2012-04-08 Text on matrix

#include <stdio.h>
#include <stdlib.h>

#include "vUtil.h"			//   
#include "iMatrix.h"    // int-matrix
#include "iMatrix3.h"   // three iMatr
#include "fonts.h"		// fonts
#include "iMatrFonts.h" // Text on matrix

//-----------------------------------------------------------------------------
//    
// (x,y) -   
int  DrawChar( matr &a, hFont &f, unsigned char ch, int x, int y, int c ) //   ch   a   (x,y)  c
{
	if( f.height()==0 ) return 0;
	if( a.My() < f.height() ) return 0;
	int w = f.width(ch)+1;
	if(w==1) return 3;		//  
	for( int dy=0; dy<f.height(); dy ++ )
	for( int dx=0; dx<w; dx ++ )
		if( f.getBit(ch, dx, dy) ) 
			a.put(x+dx, y+dy, c);
	return w;
}
//-----------------------------------------------------------------------------
void DrawText( matr &a, hFont &f, char *s, int x, int y, int c ) //   s   a   (x,y)  c
{
	int w;
	while(*s)
	{
		w = DrawChar(a, f, (unsigned char)*s, x, y, c);
		x += w;
		s++;
	}
}
//-----------------------------------------------------------------------------
void DrawText( matr3 &a3, hFont &f, char *s, int x, int y, int cr, int cg, int cb ) //   s   a3   (x,y)  (cr,cg,cb)
{
	DrawText( a3.r, f, s, x, y, cr);
	DrawText( a3.g, f, s, x, y, cg);
	DrawText( a3.b, f, s, x, y, cb);
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
